// This file is currently unlocked (change this line if you lock the file)
//
// Source code version is 2.3.0
//                        (increment this number EVERY time you make a change)
//
// History: (add to this EVERY time you make a change) 
// (insert details of your change immediately below this line)
//
// 2.3.0        16 May 1997     Jill Baker
//      Original Version
//
// If this file is unlocked, or locked by someone other than you, then you
// may download this file for incorporation into your build, however any
// changes you make to your copy of this file will be considered volatile,
// and will not be incorporated into the master build which is maintained
// at this web site.
//
// If you wish to make permanent changes to this file, you must wait until
// it becomes unlocked (if it is not unlocked already), and then lock it
// yourself. Whenever the file is locked by you, you may upload new master
// versions to the master site. Make sure you update the history information
// above. When your changes are complete, you should relinquish the lock to
// make it available for other developers.

/*
 * Copyright (C) 1995, 1996 Systemics Ltd (http://www.systemics.com/)
 * All rights reserved.
 *
 * This library and applications are FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the conditions within the COPYRIGHT file are adhered to.
 *
 */

package cryptix.math;

import java.io.InputStream;
import java.io.IOException;
import java.security.SecureRandom;

/**
 * @author Jill Baker
 */
// This could easily extend InputStream directly, making RandomStream entirely redundant.
// Existing heirarchy is retained (temporarily at least) for compatibility reasons.
public class RandomInputStream extends RandomStream
{
    private SecureRandom random;
    private int nextBytes;
    private int count;

    public RandomInputStream( SecureRandom random )
    {
        this.random = random;
        count = 4;
        nextBytes = random.nextInt();
    }

    public int read()
    {
        int ret = nextBytes & 0xFF;
        count--;
        if (count == 0)
        {
            count = 4;
            nextBytes = random.nextInt();
        }
        else
        {
            nextBytes >>>= 8;
        }
        return ret;
    }

    public int read( byte b[] )
    {
        random.nextBytes( b );
        return b.length;
    }

    public int read( byte b[], int offset, int len )
    {
        byte[] temp = new byte[ len ];
        random.nextBytes( temp );
        System.arraycopy( temp, 0, b, offset, len );
        return len;
    }

    public long skip( long n )
    {
        return n;
    }

    public void seed( long n )
    {
        random.setSeed( n );
    }

    public void seed( byte[] b )
    {
        random.setSeed( b );
    }

    public byte nextByte()
    {
        return (byte) read();
    }

    public int available()
    {
        return 8096;    // arbitrary
    }

    public boolean markSupported()
    {
        return false;
    }
}
