package cryptix.util;

import java.io.*;
import cryptix.mime.*;
import util.HexDumpEncoder;
import util.CharacterEncoder;

/**
 * Takes a base 64 string from standard input and writes byte equivalents to standard out.
 * @author Ian Brown
 * @version 1.0
 */
public final class Base64Reader
{
	public static final void main( String argv[] )
	throws IOException
	{
		DataInputStream stdin = new DataInputStream( System.in );
		String nextLine;

		String base64text = "";

		// Get base 64 string
		while ( ( nextLine = stdin.readLine() ) != null )
			base64text += nextLine;

		// Discard characters at end of string which don't make up a full byte
		// (4 base 64 characters represent 1 byte)
		int length = base64text.length() ;
		switch ( length % 4 )
		{
			case 1: base64text = base64text.substring( 0, length - 1 ); break;
			case 2: base64text = base64text.substring( 0, length - 2 ); break;
			case 3: base64text = base64text.substring( 0, length - 3 ); break;
		}	
		System.err.println( length % 4 + " character(s) discarded" );
		
		// Convert base64text to binary
		byte[] data = Base64.decode( base64text );

		// Dump it to system out in hex form
		HexDumpEncoder encoder = new HexDumpEncoder();
		encoder.encodeBuffer( data, System.out );
	}
}
